<?php
/**
*
* @package Smilies Categories
* @version $Id: install_smilie_categories.php 18 2012-04-22 13:50:16Z femu $
* @copyright (c) 2009, 2010 ExReaction, wuerzi & femu
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

// Start handle smilies categories version
if (!class_exists('umil'))
{
	include($phpbb_root_path . 'umil/umil.' . $phpEx);
}

// If you want a completely stand alone version (able to use UMIL without messing with any of the language stuff) send true, otherwise send false
$umil = new umil(true);

// Install the base 1.0.4 version
if (!$umil->table_exists($table_prefix . 'smilies_categories'))
{
	$umil = new umil(false);
}
elseif (!$umil->config_exists('smilies_categories_version') && $umil->table_column_exists($table_prefix . 'smilies_categories', 'cat_id'))
{
	// We must handle the version number ourselves.
	$umil->config_add('smilies_categories_version', '1.0.4');
	$umil = new umil(false);
}
// End handle smilies categories version

define('UMIL_AUTO', true);

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}


// The name of the mod to be displayed during installation.
$mod_name = 'SC_SMILIES_CATEGORIES_NAME';

/*
* The name of the config variable which will hold the currently installed version
* You do not need to set this yourself, UMIL will handle setting and updating the version itself.
*/

$version_config_name = 'smilies_categories_version';

/*
* The language file which will be included when installing
* Language entries that should exist in the language file for UMIL (replace $mod_name with the mod's name you set to $mod_name above)
*/
$language_file = 'mods/smilies_categories';

/*
* Optionally we may specify our own logo image to show in the upper corner instead of the default logo.
* $phpbb_root_path will get prepended to the path specified
* Image height should be 50px to prevent cut-off or stretching.
*/

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/

/**
* Define the basic structure
* The format:
*		array('{TABLE_NAME}' => {TABLE_DATA})
*		{TABLE_DATA}:
*			COLUMNS = array({column_name} = array({column_type}, {default}, {auto_increment}))
*			PRIMARY_KEY = {column_name(s)}
*			KEYS = array({key_name} = array({key_type}, {column_name(s)})),
*
*	Column Types:
*	INT:x		=> SIGNED int(x)
*	BINT		=> BIGINT
*	UINT		=> mediumint(8) UNSIGNED
*	UINT:x		=> int(x) UNSIGNED
*	TINT:x		=> tinyint(x)
*	USINT		=> smallint(4) UNSIGNED (for _order columns)
*	BOOL		=> tinyint(1) UNSIGNED
*	VCHAR		=> varchar(255)
*	CHAR:x		=> char(x)
*	XSTEXT_UNI	=> text for storing 100 characters (topic_title for example)
*	STEXT_UNI	=> text for storing 255 characters (normal input field with a max of 255 single-byte chars) - same as VCHAR_UNI
*	TEXT_UNI	=> text for storing 3000 characters (short text, descriptions, comments, etc.)
*	MTEXT_UNI	=> mediumtext (post text, large text)
*	VCHAR:x		=> varchar(x)
*	TIMESTAMP	=> int(11) UNSIGNED
*	DECIMAL		=> decimal number (5,2)
*	DECIMAL:		=> decimal number (x,2)
*	PDECIMAL		=> precision decimal number (6,3)
*	PDECIMAL:	=> precision decimal number (x,3)
*	VCHAR_UNI	=> varchar(255) BINARY
*	VCHAR_CI		=> varchar_ci for postgresql, others VCHAR
*/

$versions = array(
	// Version 1.0.4 - this is the first version using UMIL
	'1.0.4'	=> array(

		// Now to add the tables (this uses the layout from develop/create_schema_files.php and from phpbb_db_tools)
		'table_add' => array(

			array($table_prefix . 'smilies_categories', array(
					'COLUMNS'		=> array(
						'cat_id'		=> array('UINT', NULL, 'auto_increment'),
						'cat_name'		=> array('VCHAR', ''),
						'cat_count'		=> array('UINT', 0),
						'cat_icon'		=> array('VCHAR', ''),
						),
					'PRIMARY_KEY'	=> 'cat_id',
				),
			),

			array($table_prefix . 'smilies_in_cats', array(
					'COLUMNS'		=> array(
						'smiley_id'		=> array('UINT', 0),
						'cat_id'		=> array('UINT', 0),
					),
					'PRIMARY_KEY'	=> 'smiley_id, cat_id',
				),
			),
		),

		// Clear the general cache as well as the templates, imagesets and themes cache
		'cache_purge' => array(
			array(),
			array('imageset'),
			array('template'),
			array('theme'),
		),

		// Alright, now lets add some modules to the ACP
		'module_add' => array(
			// Now we will add the smilies categories into the settings settings mode to the ACP_POINTS category
			array('acp', 'ACP_MESSAGES', array(
					'module_basename'	=> 'smilies_categories',
					'module_langname'	=> 'ACP_SMILIES_CATEGORIES',
					'module_mode'		=> 'default',
					'module_auth'		=> 'acl_a_icons',
					'after'				=> 'ACP_SMILIES',
				),
			),
		),

		/*
		* Now we need to insert some data.  The easiest way to do that is through a custom function
		* Enter 'custom' for the array key and the name of the function for the value.
		*/
		'custom'	=> 'first_fill_1_0_4',
	),

	// Version 1.0.5 only update Version
	'1.0.5'		=> array(),

	// Version 1.0.6 only update Version
	'1.0.6'		=> array(),
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

/*
* Here is our custom function that will be called for version 1.0.0
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function first_fill_1_0_4($action, $version)
{
	global $db, $table_prefix, $umil;

	switch ($action)
	{
		case 'install' :
			// Run this when installing the first time
			if ($umil->table_exists($table_prefix . 'config'))
			{
				$sql_ary = array();

				$sql_ary[] = array('config_name' => 'smilies_categories_version',	'config_value' => '1.0.4',);
				$db->sql_multi_insert($table_prefix . 'config ', $sql_ary);
			}

			// Send the message, that the command was successful
			return 'SC_INSERT_FIRST_FILL';
		break;

		case 'update' :
		break;

 		case 'uninstall' :
		break;
	}
}

?>